
yarip.Loader = function(overlay)
{
	this.overlay = overlay;

	this.load = function(doc, pages)
	{
		if (!doc || doc.nodeName != "#document" || !pages) return;

		var address = yarip.getAddress(doc, yarip.MODES.page);
		if (!address) return;

		var aAddress = yarip.getAddressArray(doc, pages);
		if (this.doWhitelisting(doc, address, aAddress, pages)) this.doBlacklisting(doc, address, aAddress, pages);
	};

	this.doWhitelisting = function(doc, pageAddress, aAddress, pages)
	{
		var hasWhitelist = false;
		var hasNoBlacklist = true;

		for (var i = aAddress.length - 1; i >= 0; i--)
		{
			for (var xValue in pages[aAddress[i]].whitelist.xpaths)
			{
				if (!pages[aAddress[i]].whitelist.xpaths[xValue].deep && pageAddress != aAddress[i]) continue;

				var elements = yarip.getElementsByXPath(doc, xValue);
				if (elements) pages[aAddress[i]].whitelist.xpaths[xValue].found++; // increment `found'
				else
				{
					pages[aAddress[i]].whitelist.xpaths[xValue].notFound++; // increment `not found'
					continue;
				}

				hasWhitelist = true;
				hasNoBlacklist = hasNoBlacklist && pages[aAddress[i]].blacklist.length == 0;

				for (var j = 0; j < elements.snapshotLength; j++)
				{
					var element = elements.snapshotItem(j);
					while (element && element.nodeType == 1 && element.getAttribute("status") != "whitelisted")
					{
						element.setAttribute("status", "whitelisted");
						element = element.parentNode;
					}
				}
			}
		}

		if (hasWhitelist && hasNoBlacklist)
		{
			yarip.removeByXPath(doc, pages, pageAddress, new yarip.XPath("//*[not(@status='whitelisted')]")); // remove all except whitelisted
			var elements = yarip.getElementsByXPath(doc, "//*[@status='whitelisted']");
			if (!elements) return false;

			doc.body.style.margin = "0";

			for (var i = 0; i < elements.snapshotLength; i++)
			{
				var element = elements.snapshotItem(i);
				element.style.background = null;
				if (!element.attributes) continue;

				var tag = element.localName.toLowerCase();
				if (!tag.match(/table|td/)) continue;

				for (var j in element.attributes)
				{
					if (!element.attributes[j]) continue;

					var n = element.attributes[j].name;
					switch (n)
					{
/*						case "align":
							element.setAttribute(n, "center");
							break;*/

						case "border":
						case "cellpadding":
						case "cellspacing":
							element.setAttribute(n, "0");
							break;

						case "bgcolor":
						case "height":
							element.removeAttribute(n);
							break;

						case "valign":
							element.setAttribute(n, "top");
					}
				}
			}

			document.getElementById("yarip-statusbarpanel").setAttribute("status", "whitelisted");
			return false;
		}
		return true;
	};

	this.doBlacklisting = function(doc, pageAddress, aAddress, pages)
	{
		var found = false;

		for (var i = aAddress.length - 1; i >= 0; i--)
		{
			for (var xValue in pages[aAddress[i]].blacklist.xpaths)
			{
				var xpath = pages[aAddress[i]].blacklist.xpaths[xValue];
				if (!xpath.deep && this.checkDeep(pageAddress, aAddress[i])) continue;

				if (yarip.removeByXPath(doc, pages, aAddress[i], xpath))
				{
					found = true;
					pages[aAddress[i]].blacklist.xpaths[xValue].found++; // increment `found'
				}
				else pages[aAddress[i]].blacklist.xpaths[xValue].notFound++; // increment `not found'
			}
		}

		if (found) document.getElementById("yarip-statusbarpanel").setAttribute("status", "blacklisted");
		else document.getElementById("yarip-statusbarpanel").setAttribute("status", "enabled");
	};

	this.checkDeep = function(pageAddress, address)
	{
		if (address.match(yarip.domainRegExp))
		{
			var domain = pageAddress.match(yarip.domainRegExp);
			if (domain) return domain[0] != address;
		}
		return pageAddress != address;
	};
};
